Index: /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsink.F90
===================================================================
--- /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsink.F90	(revision 6533)
+++ /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsink.F90	(revision 6534)
@@ -40,5 +40,10 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   sinkfer2           !: Big iron sinking fluxes
 #endif
-
+#if defined key_n15
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   sink15n, sink15n2   !: N15 POC sinking fluxes
+#endif
+#if defined key_c13
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   sink13c, sink13c2, sink13cal   !: C13 POC sinking fluxes
+#endif
    INTEGER  :: ik100
 
@@ -94,4 +99,10 @@
       REAL(wp) ::   zagg , zaggfe, zaggdoc, zaggdoc2, zaggdoc3
       REAL(wp) ::   zfact, zwsmax, zmax, zstep
+#if defined key_n15 
+      REAL(wp) :: zagg_15, zratdoc_15
+#endif
+#if defined key_c13
+      REAL(wp) :: zagg_13, zratdoc_13
+#endif
       CHARACTER (len=25) :: charout
       REAL(wp), POINTER, DIMENSION(:,:,:) :: zw3d
@@ -172,5 +183,4 @@
       sinksil (:,:,:) = 0.e0
       sinkfer2(:,:,:) = 0.e0
-
       !   Compute the sedimentation term using p4zsink2 for all the sinking particles
       !   -----------------------------------------------------
@@ -187,4 +197,26 @@
       END DO
 
+#if defined key_n15
+      sink15n (:,:,:) = 0.e0
+      sink15n2(:,:,:) = 0.e0
+      DO jit = 1, iiter1
+        CALL p4z_sink2( wsbio3, sink15n , jp15poc, iiter1 )
+      END DO
+      DO jit = 1, iiter2
+        CALL p4z_sink2( wsbio4, sink15n2, jp15goc, iiter2 )
+      END DO
+#endif
+#ifdef key_c13
+      sink13c (:,:,:) = 0.e0
+      sink13c2(:,:,:) = 0.e0
+      sink13cal(:,:,:) = 0.e0
+      DO jit = 1, iiter1
+        CALL p4z_sink2( wsbio3, sink13c , jp13poc, iiter1 )
+      END DO
+      DO jit = 1, iiter2
+        CALL p4z_sink2( wsbio4, sink13c2, jp13goc, iiter2 )
+        CALL p4z_sink2( wscal , sink13cal,jp13cal, iiter2 )
+      END DO
+#endif
       !  Exchange between organic matter compartments due to coagulation/disaggregation
       !  ---------------------------------------------------
@@ -230,4 +262,21 @@
                tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) + zaggfe
                tra(ji,jj,jk,jpdoc) = tra(ji,jj,jk,jpdoc) - zaggdoc - zaggdoc2 - zaggdoc3
+#if defined key_n15
+               zagg_15 = zagg * trb(ji,jj,jk,jp15poc) / ( trb(ji,jj,jk,jppoc) + rtrn )
+               zratdoc_15 = trb(ji,jj,jk,jp15doc)/ ( trb(ji,jj,jk,jpdoc) + rtrn )
+               tra(ji,jj,jk,jp15poc) = tra(ji,jj,jk,jp15poc) - zagg_15 + ( zaggdoc + zaggdoc3 ) * zratdoc_15
+               tra(ji,jj,jk,jp15goc) = tra(ji,jj,jk,jp15goc) + zagg_15 + zaggdoc2 * zratdoc_15
+               tra(ji,jj,jk,jp15doc) = tra(ji,jj,jk,jp15doc) - ( zaggdoc + zaggdoc2 + zaggdoc3 )   &
+               &                       * zratdoc_15
+#endif
+#if defined key_c13
+               zagg_13 = zagg * trb(ji,jj,jk,jp13poc) / ( trb(ji,jj,jk,jppoc) + rtrn )
+               zratdoc_13 = trb(ji,jj,jk,jp13doc)/ ( trb(ji,jj,jk,jpdoc) + rtrn)
+               tra(ji,jj,jk,jp13poc) = tra(ji,jj,jk,jp13poc) - zagg_13 + ( zaggdoc + zaggdoc3 ) * zratdoc_13
+               tra(ji,jj,jk,jp13goc) = tra(ji,jj,jk,jp13goc) + zagg_13 + zaggdoc2 * zratdoc_13
+               tra(ji,jj,jk,jp13doc) = tra(ji,jj,jk,jp13doc) - ( zaggdoc + zaggdoc2 + zaggdoc3 )   &
+               &                       * zratdoc_13
+#endif
+
                !
             END DO
@@ -891,5 +940,11 @@
       ALLOCATE( wsbio3 (jpi,jpj,jpk) , wsbio4  (jpi,jpj,jpk) , wscal(jpi,jpj,jpk) ,     &
          &      sinking(jpi,jpj,jpk) , sinking2(jpi,jpj,jpk)                      ,     &                
-         &      sinkcal(jpi,jpj,jpk) , sinksil (jpi,jpj,jpk)                      ,     &                
+         &      sinkcal(jpi,jpj,jpk) , sinksil (jpi,jpj,jpk)                      ,     &  
+#if defined key_n15
+         &      sink15n(jpi,jpj,jpk) , sink15n2(jpi,jpj,jpk)                      ,     &
+#endif       
+#if defined key_c13
+         &      sink13c(jpi,jpj,jpk) , sink13c2(jpi,jpj,jpk), sink13cal(jpi,jpj,jpk) ,     &
+#endif        
 #if defined key_kriest
          &      xnumm(jpk)                                                        ,     &                
@@ -913,3 +968,3 @@
 
    !!======================================================================
-END MODULE p4zsink
+END MODULE  p4zsink
Index: /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsms.F90
===================================================================
--- /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsms.F90	(revision 6533)
+++ /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsms.F90	(revision 6534)
@@ -71,4 +71,7 @@
       INTEGER ::   ji, jj, jk, jnt, jn, jl
       REAL(wp) ::  ztra
+#if defined key_n15
+      REAL(wp) ::  zn15min, zn15max
+#endif
 #if defined key_kriest
       REAL(wp) ::  zcoef1, zcoef2
@@ -133,8 +136,7 @@
          !
          CALL p4z_bio( kt, jnt )   ! Biology
+         CALL p4z_sed( kt, jnt )   ! Sedimentation
          CALL p4z_lys( kt, jnt )   ! Compute CaCO3 saturation
-         CALL p4z_sed( kt, jnt )   ! Surface and Bottom boundary conditions
          CALL p4z_flx( kt, jnt )   ! Compute surface fluxes
-         !
          xnegtr(:,:,:) = 1.e0
          DO jn = jp_pcs0, jp_pcs1
@@ -153,5 +155,5 @@
          !                                ! 
          DO jn = jp_pcs0, jp_pcs1
-           trb(:,:,:,jn) = trb(:,:,:,jn) + xnegtr(:,:,:) * tra(:,:,:,jn)
+           trb(:,:,:,jn) = trb(:,:,:,jn) + xnegtr(:,:,:) * tra(:,:,:,jn) * tmask(:,:,:)
          END DO
         !
@@ -159,5 +161,13 @@
             tra(:,:,:,jn) = 0._wp
          END DO
-         !
+        !
+#if defined key_n15
+         zn15min = -30.
+         zn15max = 30.
+         !
+         trb(:,:,:,jp15no3) = MIN(trb(:,:,:,jp15no3) , ( (zn15max/1000.)  + 1.)*trb(:,:,:,jpno3) )
+         trb(:,:,:,jp15no3) = MAX(trb(:,:,:,jp15no3) , ( (zn15min/1000.)  + 1.)*trb(:,:,:,jpno3) )
+#endif
+      !
          IF( ln_top_euler ) THEN
             DO jn = jp_pcs0, jp_pcs1
@@ -166,5 +176,5 @@
          ENDIF
       END DO
-
+      !
 #if defined key_kriest
       ! 
Index: /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/par_pisces.F90
===================================================================
--- /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/par_pisces.F90	(revision 6533)
+++ /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/par_pisces.F90	(revision 6534)
@@ -75,4 +75,5 @@
    INTEGER, PUBLIC, PARAMETER ::   jpnh4 = 23    !: Ammonium Concentration
 
+
 #elif defined key_pisces
    !!---------------------------------------------------------------------
@@ -82,12 +83,16 @@
    LOGICAL, PUBLIC, PARAMETER ::   lk_p4z        = .TRUE.  !: p4z flag 
    LOGICAL, PUBLIC, PARAMETER ::   lk_kriest     = .FALSE. !: Kriest flag 
-   INTEGER, PUBLIC, PARAMETER ::   jp_pisces     = 24      !: number of PISCES passive tracers
-   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_2d  = 13      !: additional 2d output 
-   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_3d  = 11      !: additional 3d output 
-   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_trd =  1      !: number of sms trends for PISCES
 
    ! assign an index in trc arrays for each LOBSTER prognostic variables
    !    WARNING: be carefull about the order when reading the restart
         !   !!gm  this warning should be obsolet with IOM
+#if ! defined key_n15  && ! defined key_c13
+   LOGICAL, PUBLIC, PARAMETER ::   lk_n15        = .FALSE.  !: N15 flag 
+   LOGICAL, PUBLIC, PARAMETER ::   lk_c13        = .FALSE.  !: C13 flag 
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces     = 24      !: number of PISCES passive tracers
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_2d  = 20      !: additional 2d output 
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_3d  = 14      !: additional 3d output 
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_trd =  1      !: number of sms trends for PISCES
+#endif
    INTEGER, PUBLIC, PARAMETER ::   jpdic =  1    !: dissolved inoganic carbon concentration 
    INTEGER, PUBLIC, PARAMETER ::   jptal =  2    !: total alkalinity 
@@ -115,4 +120,71 @@
    INTEGER, PUBLIC, PARAMETER ::   jpnh4 = 24    !: Ammonium Concentration
 
+#if defined key_n15  && defined key_c13
+   LOGICAL, PUBLIC, PARAMETER ::   lk_n15        = .TRUE.  !: N15 flag 
+   LOGICAL, PUBLIC, PARAMETER ::   lk_c13        = .TRUE.  !: C13 flag 
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces     = 42      !: number of PISCES passive tracers
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_2d  = 20      !: additional 2d output 
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_3d  = 14      !: additional 3d output 
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_trd =  1      !: number of sms trends for PISCES
+
+   INTEGER, PUBLIC, PARAMETER ::   jp15poc = 25  !: 15N small particulate organic concentration
+   INTEGER, PUBLIC, PARAMETER ::   jp15phy = 26  !: 15N phytoplancton concentration 
+   INTEGER, PUBLIC, PARAMETER ::   jp15zoo = 27  !: 15N zooplancton concentration
+   INTEGER, PUBLIC, PARAMETER ::   jp15doc = 28  !: 15N dissolved organic carbon concentration 
+   INTEGER, PUBLIC, PARAMETER ::   jp15dia = 29  !: 15N Diatoms Concentration
+   INTEGER, PUBLIC, PARAMETER ::   jp15mes = 30  !: 15N Mesozooplankton Concentration
+   INTEGER, PUBLIC, PARAMETER ::   jp15goc = 31  !: 15N big particulate organic concentration
+   INTEGER, PUBLIC, PARAMETER ::   jp15no3 = 32  !: 15N Nitrates Concentration
+   INTEGER, PUBLIC, PARAMETER ::   jp15nh4 = 33  !: 15N Ammonium Concentration
+
+   INTEGER, PUBLIC, PARAMETER ::   jp13dic = 34  !: 13C dissolved inorganic concentration
+   INTEGER, PUBLIC, PARAMETER ::   jp13cal = 35  !: 13C calcite Concentration
+   INTEGER, PUBLIC, PARAMETER ::   jp13poc = 36  !: 13C small particulate organic concentration
+   INTEGER, PUBLIC, PARAMETER ::   jp13phy = 37  !: 13C phytoplancton concentration 
+   INTEGER, PUBLIC, PARAMETER ::   jp13zoo = 38  !: 13C zooplancton concentration
+   INTEGER, PUBLIC, PARAMETER ::   jp13doc = 39  !: 13C dissolved organic carbon concentration 
+   INTEGER, PUBLIC, PARAMETER ::   jp13dia = 40  !: 13C Diatoms Concentration
+   INTEGER, PUBLIC, PARAMETER ::   jp13mes = 41  !: 13C Mesozooplankton Concentration
+   INTEGER, PUBLIC, PARAMETER ::   jp13goc = 42  !: 13C big particulate organic concentration
+#endif
+#if defined key_n15  && ! defined key_c13
+   LOGICAL, PUBLIC, PARAMETER ::   lk_n15        = .TRUE.  !: N15 flag 
+   LOGICAL, PUBLIC, PARAMETER ::   lk_c13        = .FALSE.  !: C13 flag 
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces     = 33      !: number of PISCES passive tracers
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_2d  = 20      !: additional 2d output 
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_3d  = 14      !: additional 3d output 
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_trd =  1      !: number of sms trends for PISCES
+
+   INTEGER, PUBLIC, PARAMETER ::   jp15poc = 25  !: 15N small particulate organic phosphate concentration
+   INTEGER, PUBLIC, PARAMETER ::   jp15phy = 26  !: 15N phytoplancton concentration 
+   INTEGER, PUBLIC, PARAMETER ::   jp15zoo = 27  !: 15N zooplancton concentration
+   INTEGER, PUBLIC, PARAMETER ::   jp15doc = 28  !: 15N dissolved organic carbon concentration 
+   INTEGER, PUBLIC, PARAMETER ::   jp15dia = 29  !: 15N Diatoms Concentration
+   INTEGER, PUBLIC, PARAMETER ::   jp15mes = 30  !: 15N Mesozooplankton Concentration
+   INTEGER, PUBLIC, PARAMETER ::   jp15goc = 31  !: 15N big particulate organic phosphate concentration
+   INTEGER, PUBLIC, PARAMETER ::   jp15no3 = 32  !: 15N Nitrates Concentration
+   INTEGER, PUBLIC, PARAMETER ::   jp15nh4 = 33  !: 15N Ammonium Concentration
+#endif
+#if ! defined key_n15  &&  defined key_c13
+   LOGICAL, PUBLIC, PARAMETER ::   lk_n15        = .FALSE.  !: N15 flag 
+   LOGICAL, PUBLIC, PARAMETER ::   lk_c13        = .TRUE.  !: C13 flag 
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces     = 33      !: number of PISCES passive tracers
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_2d  = 20      !: additional 2d output 
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_3d  = 14      !: additional 3d output 
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_trd =  1      !: number of sms trends for PISCES
+
+   INTEGER, PUBLIC, PARAMETER ::   jp13dic = 25  !: 13C dissolved inorganic concentration
+   INTEGER, PUBLIC, PARAMETER ::   jp13cal = 26  !: 13C calcite Concentration
+   INTEGER, PUBLIC, PARAMETER ::   jp13poc = 27  !: 13C small particulate organic concentration
+   INTEGER, PUBLIC, PARAMETER ::   jp13phy = 28  !: 13C phytoplancton concentration 
+   INTEGER, PUBLIC, PARAMETER ::   jp13zoo = 29  !: 13C zooplancton concentration
+   INTEGER, PUBLIC, PARAMETER ::   jp13doc = 30  !: 13C dissolved organic carbon concentration 
+   INTEGER, PUBLIC, PARAMETER ::   jp13dia = 31  !: 13C Diatoms Concentration
+   INTEGER, PUBLIC, PARAMETER ::   jp13mes = 32  !: 13C Mesozooplankton Concentration
+   INTEGER, PUBLIC, PARAMETER ::   jp13goc = 33  !: 13C big particulate organic concentration
+#endif
+
+#endif
+
 #else
    !!---------------------------------------------------------------------
Index: /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/trcini_pisces.F90
===================================================================
--- /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/trcini_pisces.F90	(revision 6533)
+++ /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/trcini_pisces.F90	(revision 6534)
@@ -159,4 +159,27 @@
       END IF
 
+#if defined key_n15
+      trn(:,:,:,jp15doc) = trn(:,:,:,jpdoc)
+      trn(:,:,:,jp15poc) = trn(:,:,:,jppoc)
+      trn(:,:,:,jp15goc) = trn(:,:,:,jpgoc)
+      trn(:,:,:,jp15phy) = trn(:,:,:,jpphy)
+      trn(:,:,:,jp15dia) = trn(:,:,:,jpdia)
+      trn(:,:,:,jp15zoo) = trn(:,:,:,jpzoo)
+      trn(:,:,:,jp15mes) = trn(:,:,:,jpmes)
+      trn(:,:,:,jp15no3) = trn(:,:,:,jpno3)
+      trn(:,:,:,jp15nh4) = trn(:,:,:,jpnh4)
+#endif
+#if defined key_c13
+      trn(:,:,:,jp13doc) = trn(:,:,:,jpdoc)
+      trn(:,:,:,jp13poc) = trn(:,:,:,jppoc)
+      trn(:,:,:,jp13goc) = trn(:,:,:,jpgoc)
+      trn(:,:,:,jp13phy) = trn(:,:,:,jpphy)
+      trn(:,:,:,jp13dia) = trn(:,:,:,jpdia)
+      trn(:,:,:,jp13zoo) = trn(:,:,:,jpzoo)
+      trn(:,:,:,jp13mes) = trn(:,:,:,jpmes)
+      trn(:,:,:,jp13dic) = trn(:,:,:,jpdic)
+      trn(:,:,:,jp13cal) = trn(:,:,:,jpcal)
+#endif
+
 
       CALL p4z_sink_init      !  vertical flux of particulate organic matter
Index: /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/trcwri_pisces.F90
===================================================================
--- /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/trcwri_pisces.F90	(revision 6533)
+++ /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/trcwri_pisces.F90	(revision 6534)
@@ -47,4 +47,7 @@
          zfact = 1.0e+6 
          IF( jn == jpno3 .OR. jn == jpnh4 ) zfact = rno3 * 1.0e+6 
+#if defined key_n15
+         IF( jn == jp15no3 .OR. jn == jp15nh4 ) zfact = rno3 * 1.0e+6
+#endif
          IF( jn == jppo4  )                 zfact = po4r * 1.0e+6
          cltra = TRIM( ctrcnm(jn) )                  ! short title for tracer
